#ifndef __IPLIST_H__
#define __IPLIST_H__

#define IPLIST_ERR_INVAL  -1
#define IPLIST_ERR_EXIST  -2
#define IPLIST_ERR_TREE   -3
#define IPLIST_ERR_NOMEM  -4
#define IPLIST_SUCCESS     0

#include "patricia.h"

#ifdef WIN32
typedef long in_addr_t;
#endif

#ifdef __cplusplus
extern "C" {
#endif

struct simple_iphead {
	patricia_tree_t* head;
	patricia_tree_t* head_ipv6;
	void (*free_func)(void*);
};

#define MAX_SUBNETS_IN_RANGE 64

struct simple_ip_cidr {
	in_addr_t ip;
	int cidr;
	void *data;
};

typedef struct _ns_ipaddr {
	int family;
	union {
		in_addr_t ip;
		struct in6_addr ip6;
	} addr;
} ns_ipaddr;

int simple_iplist_add_string(struct simple_iphead* head, char * ipaddr, void *data);
void* simple_iplist_find_data(struct simple_iphead* head, ns_ipaddr *ip);
void* simple_iplist_init(void (*free_func)(void*), int (*match_func)(patricia_node_t* node));

#ifdef __cplusplus
}
#endif

#endif
